﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Win32;
using System.Management;

namespace TweakAPI.Info
{
    /// <summary>
    /// Provides information about audio codecs.
    /// </summary>
    public static class Audio
    {
        /// <summary>
        /// Returns an array containing the captions of installed audio codecs on your computer.
        /// </summary>
        public static string[] EnumerateCodecs()
        {
            List<string> codecs = new List<string>();
            RegistryKey regKey = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\drivers.desc", 
                RegistryKeyPermissionCheck.ReadSubTree);
            string[] regEntries = regKey.GetValueNames();
            string codec = "";
            if (regEntries != null)
            {
                foreach (string regCodec in regEntries)
                {
                    codec = regKey.GetValue(regCodec, "null").ToString();
                    codecs.Add(codec);
                }
            }
            return codecs.ToArray();
        }
    }
}
